{ pkgs, config }:

let
  scheme = config.colorScheme;
  colors = scheme.colors;
  dither = "burkes"; # none | floyd-steinberg | atkinson | jjn | burkes | sierra | sierra-lite
in
pkgs.stdenv.mkDerivation rec {
    name = "generated-wallpaper-${scheme.slug}";
    version = "e7c1034d2f89d56877e1d2a1fac33087";
    src = pkgs.fetchFromGitea {
        domain = "git.helcel.net";
        owner = "sora";
        repo = "nixconfig-wallpaper";
        rev = version;
        sha256 = "sha256-LRdWXGPwQYbWVGqXUMaRcVt3nGX6Ih0VxchMqH5NxtU=";
    };

    buildInputs = with pkgs; [
        custom.repalette
        nodejs
    ];

    configurePhase = ''
        echo "${colors.base08},${colors.base09},${colors.base0A},${colors.base0B},${colors.base0C},${colors.base0D},${colors.base0E},${colors.base0F}" > palette.in
    '';

    buildPhase = ''
        make DITHER=${dither} all
    '';

    installPhase = ''
        mkdir -p $out/share/wallpaper
        cp build/* $out/share/wallpaper/
    '';
}